; Tab Control example
; 6/2004
;
        .386
        .model flat, stdcall            ; 32 bit memory model
        option casemap :none            ; Case sensitive
;
; Includes
;---------------------------------------
        include     \masm32\include\windows.inc
        include     \masm32\include\user32.inc
        include     \masm32\include\kernel32.inc
        include     \masm32\include\comctl32.inc
;
; Libraries
;---------------------------------------
        includelib  \masm32\lib\kernel32.lib
        includelib  \masm32\lib\user32.lib
        includelib  \masm32\lib\comctl32.lib
;
; Prototypes
;---------------------------------------
WinMain PROTO   hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdShow:SDWORD
;
.const
;---------------------------------------
IDC_TAB1        equ 1011                ; The Tab Control identifier
;
.data
;---------------------------------------
MainDlgName     db  "IDD_DIALOG1", 0    ; lpTemplateName for the main dlg
Child1Name      db  "IDD_CHILD1", 0     ; lpTemplateName for the first child
Child2Name      db  "IDD_CHILD2", 0     ; lpTemplateName for the second child
TabTitle1       db  "First Tab", 0
TabTitle2       db  "Second Tab", 0     ; Pretty much speak for themselves dont they?
;
.data?
;---------------------------------------
hInstance       HINSTANCE   ?   ; App instance handle
hwndTab         HANDLE      ?   ; Handle for the Tab Control
Handles         LABEL DWORD             ; We'll use this as a reference to locate the handles
Child1hWnd      HANDLE      ?   ; Handle for the first child dialog
Child2hWnd      HANDLE      ?   ; Handle for child dialog number 2
ItemStruct      TC_ITEM         <?> ; Structure used by the Tab Control
WhichTabChosen  DWORD          ?   ; Sort of flag which will prove to be VERY usefull :)
;
;
.code
;---------------------------------------
Start:  invoke  GetModuleHandle, NULL
        mov     hInstance, eax
        invoke  WinMain, hInstance, NULL, SW_SHOWDEFAULT
        invoke  ExitProcess, eax
;
;
WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdShow:SDWORD
;---------------------------------------
    mov     eax, OFFSET DlgProc
    invoke  DialogBoxParam, hInst, OFFSET MainDlgName, NULL, eax, NULL
    ret
;---------------------------------------
WinMain endp
;
;
DlgProc proc    hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
;---------------------------------------
        mov     eax, uMsg
        cmp     eax, WM_CLOSE
        jz      closed
        cmp     eax, WM_INITDIALOG
        jz      initdialog
        cmp     eax, WM_COMMAND
        jz      commander
        cmp     eax, WM_NOTIFY
        jz      notify
        xor     eax, eax
        ret
notify: mov     eax, lParam                             ; lParam is a pointer to a NMHDR Struct
        mov     eax, (NMHDR PTR [eax]).code             ; Is the code member a TCN_SELCHANGE?
        cmp     eax, TCN_SELCHANGE          ;
        jz      ChangingTab                             ; Yeah, jump!
        ret                                             ; No! go back
ChangingTab:
        mov     ebx, WhichTabChosen                     ; Which is the currently selected tab?
        mov     eax, [Handles+ebx*4]                    ; Put its handle in eax
        invoke  ShowWindow, eax, SW_HIDE
        invoke  SendMessage, hwndTab, TCM_GETCURSEL, 0, 0
        mov     WhichTabChosen, eax                     ; Lets keep it in our little variable and
        mov     ebx, [Handles+eax*4]                    ; Retrieve the chosen one's handle
        invoke  ShowWindow, ebx, SW_SHOWDEFAULT         ; Now, let's show it :)
        ret
closed: invoke  ExitProcess, 0
        ret
initdialog:
        invoke  InitCommonControls
        invoke  GetDlgItem, hWnd, IDC_TAB1              ; Get the handle to the Tab Control
        mov     hwndTab, eax                            ; Lets keep it in hwndTab
        ;-------------------------------;
        ; Here we add the tabs to the   ;
        ; tab control  Also, filling in ;
        ; the TC_ITEM Structure.        ;
        ;-------------------------------;
        mov     ItemStruct.imask, TCIF_TEXT             ; Text? image? what do you want?
        mov     ItemStruct.lpReserved1, 0               ; Reserved
        mov     ItemStruct.lpReserved2, 0               ; Reserved
        mov     ItemStruct.pszText,OFFSET TabTitle1     ; Pointer to string containing tab text
        mov     ItemStruct.cchTextMax, sizeof TabTitle1 ; Size of pszText
        mov     ItemStruct.iImage, 0                    ; Index to tab control's image
        mov     ItemStruct.lParam, 0                    ; Extra info
        invoke  SendMessage, hwndTab, TCM_INSERTITEM, 0, OFFSET ItemStruct
        ; Now we add the second Tab title
        mov     ItemStruct.pszText, OFFSET TabTitle2
        mov     ItemStruct.cchTextMax, sizeof TabTitle2
        invoke  SendMessage, hwndTab, TCM_INSERTITEM, 1, OFFSET ItemStruct
        ;-------------------------------;
        ; Create the dialogs that will  ;
        ; fit in the tab control.  This ;
        ; is the first CHILD dialogbox. ;
        ;-------------------------------;
        mov     eax, OFFSET ChildDlgProc
        invoke  CreateDialogParam, hInstance, OFFSET Child1Name, hwndTab, eax, 0
        mov     Child1hWnd, eax
        ; You guessed it, this is the second one :)
        mov     eax, OFFSET ChildDlgProc
        invoke  CreateDialogParam, hInstance, OFFSET Child2Name, hwndTab, eax, 0
        mov     Child2hWnd, eax
        mov     WhichTabChosen, 0
        ;-------------------------------;
        ; Let's initialize our variable ;
        ; with 0, since we will start   ;
        ; showing the first dialog box  ;
        ; and its index is 0.           ;
        ;-------------------------------;
        invoke  ShowWindow, Child1hWnd, SW_SHOWDEFAULT
        ; Here we show the recently created child dialog box
        ret
commander:
        mov     eax, wParam
        ret
;---------------------------------------
DlgProc endp
;
;
ChildDlgProc    PROC SmallhWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
;---------------------------------------
        mov     eax, uMsg
        XOR     eax, eax
        ret
;---------------------------------------
ChildDlgProc    ENDP
;
;
        end     Start

